/*
 * Created on 21.01.2005
 */
package com;

import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.SecretKeySpec;

/**
 * @author nemo
 */
public class CipherUtility {

	public static final String _PBEWITHMD5ANDDES = "PBEWithMD5AndDES";

	//public static final String _PBEWithHmacSHA1AndDESede = "PBEWithHmacSHA1AndDESede";

	public static final String _AES = "AES";

	public static final String _Blowfish = "Blowfish";

	public static final String _DES = "DES";

	public static final String _DESede = "DESede";

	public static final String _RC2 = "RC2";

	public static final String _RC4 = "RC4";

	byte[] salt = { (byte) 0xc7, (byte) 0x73, (byte) 0x21, (byte) 0x8c, (byte) 0x7e, (byte) 0xc8, (byte) 0xee,
			(byte) 0x99 };

	private Base64 bbase = new Base64();

	public class Base64 {

		/**
		 * Translates the specified byte array into a Base64 string as per
		 * Preferences.put(byte[]).
		 */
		private String byteArrayToBase64(byte[] a) {
			return byteArrayToBase64(a, false);
		}

		/**
		 * This array is a lookup table that translates 6-bit positive integer index
		 * values into their "Base64 Alphabet" equivalents as specified in Table 1
		 * of RFC 2045.
		 */
		private final char intToBase64[] = { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
				'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
				'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2',
				'3', '4', '5', '6', '7', '8', '9', '+', '/' };

		/**
		 * Translates the specified byte array into an "aternate representation"
		 * Base64 string. This non-standard variant uses an alphabet that does not
		 * contain the uppercase alphabetic characters, which makes it suitable for
		 * use in situations where case-folding occurs.
		 */
		private String byteArrayToAltBase64(byte[] a) {
			return byteArrayToBase64(a, true);
		}

		private String byteArrayToBase64(byte[] a, boolean alternate) {
			int aLen = a.length;
			int numFullGroups = aLen / 3;
			int numBytesInPartialGroup = aLen - 3 * numFullGroups;
			int resultLen = 4 * ((aLen + 2) / 3);
			StringBuffer result = new StringBuffer(resultLen);
			char[] intToAlpha = (alternate ? intToAltBase64 : intToBase64);

			// Translate all full groups from byte array elements to Base64
			int inCursor = 0;
			for (int i = 0; i < numFullGroups; i++) {
				int byte0 = a[inCursor++] & 0xff;
				int byte1 = a[inCursor++] & 0xff;
				int byte2 = a[inCursor++] & 0xff;
				result.append(intToAlpha[byte0 >> 2]);
				result.append(intToAlpha[(byte0 << 4) & 0x3f | (byte1 >> 4)]);
				result.append(intToAlpha[(byte1 << 2) & 0x3f | (byte2 >> 6)]);
				result.append(intToAlpha[byte2 & 0x3f]);
			}

			// Translate partial group if present
			if (numBytesInPartialGroup != 0) {
				int byte0 = a[inCursor++] & 0xff;
				result.append(intToAlpha[byte0 >> 2]);
				if (numBytesInPartialGroup == 1) {
					result.append(intToAlpha[(byte0 << 4) & 0x3f]);
					result.append("==");
				} else {
					// assert numBytesInPartialGroup == 2;
					int byte1 = a[inCursor++] & 0xff;
					result.append(intToAlpha[(byte0 << 4) & 0x3f | (byte1 >> 4)]);
					result.append(intToAlpha[(byte1 << 2) & 0x3f]);
					result.append('=');
				}
			}
			// assert inCursor == a.length;
			// assert result.length() == resultLen;
			return result.toString();
		}

		/**
		 * This array is a lookup table that translates 6-bit positive integer index
		 * values into their "Alternate Base64 Alphabet" equivalents. This is NOT
		 * the real Base64 Alphabet as per in Table 1 of RFC 2045. This alternate
		 * alphabet does not use the capital letters. It is designed for use in
		 * environments where "case folding" occurs.
		 */
		private final char intToAltBase64[] = { '!', '"', '#', '$', '%', '&', '\'', '(', ')', ',', '-', '.', ':', ';',
				'<', '>', '@', '[', ']', '^', '`', '_', '{', '|', '}', '~', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h',
				'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1',
				'2', '3', '4', '5', '6', '7', '8', '9', '+', '?' };

		/**
		 * Translates the specified Base64 string (as per Preferences.get(byte[]))
		 * into a byte array.
		 * 
		 * @throw IllegalArgumentException if <tt>s</tt> is not a valid Base64
		 *        string.
		 */
		private byte[] base64ToByteArray(String s) {
			return base64ToByteArray(s, false);
		}

		/**
		 * Translates the specified "aternate representation" Base64 string into a
		 * byte array.
		 * 
		 * @throw IllegalArgumentException or ArrayOutOfBoundsException if
		 *        <tt>s</tt> is not a valid alternate representation Base64
		 *        string.
		 */
		private byte[] altBase64ToByteArray(String s) {
			return base64ToByteArray(s, true);
		}

		private byte[] base64ToByteArray(String s, boolean alternate) {
			byte[] alphaToInt = (alternate ? altBase64ToInt : base64ToInt);
			int sLen = s.length();
			int numGroups = sLen / 4;
			if (4 * numGroups != sLen)
				throw new IllegalArgumentException("String length must be a multiple of four.");
			int missingBytesInLastGroup = 0;
			int numFullGroups = numGroups;
			if (sLen != 0) {
				if (s.charAt(sLen - 1) == '=') {
					missingBytesInLastGroup++;
					numFullGroups--;
				}
				if (s.charAt(sLen - 2) == '=')
					missingBytesInLastGroup++;
			}
			byte[] result = new byte[3 * numGroups - missingBytesInLastGroup];

			// Translate all full groups from base64 to byte array elements
			int inCursor = 0, outCursor = 0;
			for (int i = 0; i < numFullGroups; i++) {
				int ch0 = base64toInt(s.charAt(inCursor++), alphaToInt);
				int ch1 = base64toInt(s.charAt(inCursor++), alphaToInt);
				int ch2 = base64toInt(s.charAt(inCursor++), alphaToInt);
				int ch3 = base64toInt(s.charAt(inCursor++), alphaToInt);
				result[outCursor++] = (byte) ((ch0 << 2) | (ch1 >> 4));
				result[outCursor++] = (byte) ((ch1 << 4) | (ch2 >> 2));
				result[outCursor++] = (byte) ((ch2 << 6) | ch3);
			}

			// Translate partial group, if present
			if (missingBytesInLastGroup != 0) {
				int ch0 = base64toInt(s.charAt(inCursor++), alphaToInt);
				int ch1 = base64toInt(s.charAt(inCursor++), alphaToInt);
				result[outCursor++] = (byte) ((ch0 << 2) | (ch1 >> 4));

				if (missingBytesInLastGroup == 1) {
					int ch2 = base64toInt(s.charAt(inCursor++), alphaToInt);
					result[outCursor++] = (byte) ((ch1 << 4) | (ch2 >> 2));
				}
			}
			// assert inCursor == s.length()-missingBytesInLastGroup;
			// assert outCursor == result.length;
			return result;
		}

		/**
		 * Translates the specified character, which is assumed to be in the "Base
		 * 64 Alphabet" into its equivalent 6-bit positive integer.
		 * 
		 * @throw IllegalArgumentException or ArrayOutOfBoundsException if c is not
		 *        in the Base64 Alphabet.
		 */
		private int base64toInt(char c, byte[] alphaToInt) {
			int result = alphaToInt[c];
			if (result < 0)
				throw new IllegalArgumentException("Illegal character " + c);
			return result;
		}

		/**
		 * This array is a lookup table that translates unicode characters drawn
		 * from the "Base64 Alphabet" (as specified in Table 1 of RFC 2045) into
		 * their 6-bit positive integer equivalents. Characters that are not in the
		 * Base64 alphabet but fall within the bounds of the array are translated to
		 * -1.
		 */
		private byte base64ToInt[] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
				-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1,
				-1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8,
				9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28,
				29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51 };

		/**
		 * This array is the analogue of base64ToInt, but for the nonstandard
		 * variant that avoids the use of uppercase alphabetic characters.
		 */
		private byte altBase64ToInt[] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
				-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, -1, 62, 9, 10, 11,
				-1, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 12, 13, 14, -1, 15, 63, 16, -1, -1, -1, -1, -1, -1, -1, -1,
				-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 17, -1, 18, 19, 21, 20, 26, 27,
				28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 22, 23,
				24, 25 };
	}

	public static CipherUtility getInstance() {
		return new CipherUtility();
	}

	public String getKey(String cipherName) throws NoSuchAlgorithmException {
		KeyGenerator kgen = KeyGenerator.getInstance(cipherName);
		SecretKey skey = kgen.generateKey();
		byte[] araw = skey.getEncoded();
		return bbase.byteArrayToBase64(araw);
	}

	public String encryptStringPBE(String srcString, String cipherName, String pass) throws NoSuchAlgorithmException,
			InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException,
			IllegalBlockSizeException, BadPaddingException {
		byte[] ciphertext = preparePBECrypt(cipherName, pass, Cipher.ENCRYPT_MODE).doFinal(srcString.getBytes());
		return bbase.byteArrayToBase64(ciphertext);
	}

	public String decryptStringPBE(String srcString, String cipherName, String pass) throws NoSuchAlgorithmException,
			InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException,
			IllegalBlockSizeException, BadPaddingException {
		byte[] encrypted = bbase.base64ToByteArray(srcString);
		byte[] decrypted = preparePBECrypt(cipherName, pass, Cipher.DECRYPT_MODE).doFinal(encrypted);
		return new String(decrypted);
	}

	public String encryptByteArrayToStringPBE(byte[] srcArray, String cipherName, String pass)
			throws NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException,
			InvalidAlgorithmParameterException, IllegalBlockSizeException, BadPaddingException {
		byte[] ciphertext = preparePBECrypt(cipherName, pass, Cipher.ENCRYPT_MODE).doFinal(srcArray);
		return bbase.byteArrayToBase64(ciphertext);
	}

	public byte[] decryptStringToByteArrayPBE(String srcString, String cipherName, String pass)
			throws NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException,
			InvalidAlgorithmParameterException, IllegalBlockSizeException, BadPaddingException {
		byte[] encrypted = bbase.base64ToByteArray(srcString);
		byte[] decrypted = preparePBECrypt(cipherName, pass, Cipher.DECRYPT_MODE).doFinal(encrypted);
		return decrypted;
	}

	public byte[] encryptByteArrayPBE(byte[] srcArray, String cipherName, String pass) throws NoSuchAlgorithmException,
			InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException,
			IllegalBlockSizeException, BadPaddingException {
		return preparePBECrypt(cipherName, pass, Cipher.ENCRYPT_MODE).doFinal(srcArray);
	}

	public byte[] decryptByteArrayPBE(byte[] srcArray, String cipherName, String pass) throws NoSuchAlgorithmException,
			InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException,
			IllegalBlockSizeException, BadPaddingException {
		return preparePBECrypt(cipherName, pass, Cipher.DECRYPT_MODE).doFinal(srcArray);
	}

	private Cipher preparePBECrypt(String cipherName, String pass, int mode) throws NoSuchAlgorithmException,
			InvalidKeySpecException, NoSuchPaddingException, InvalidKeyException, InvalidAlgorithmParameterException {
		PBEKeySpec pbeKeySpec;
		PBEParameterSpec pbeParamSpec;
		SecretKeyFactory keyFac;
		int count = 20;
		pbeParamSpec = new PBEParameterSpec(salt, count);
		pbeKeySpec = new PBEKeySpec(pass.toCharArray());
		keyFac = SecretKeyFactory.getInstance(cipherName);
		SecretKey pbeKey = keyFac.generateSecret(pbeKeySpec);
		Cipher pbeCipher = Cipher.getInstance(cipherName);
		pbeCipher.init(mode, pbeKey, pbeParamSpec);
		return pbeCipher;
	}

	public String encryptString(String srcString, String keyString, String cipherName) throws NoSuchAlgorithmException,
			NoSuchPaddingException, InvalidKeyException, IllegalBlockSizeException, BadPaddingException {
		byte[] araw = bbase.base64ToByteArray(keyString);
		SecretKeySpec skeySpec = new SecretKeySpec(araw, cipherName);
		Cipher cipher = Cipher.getInstance(cipherName);
		cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
		byte[] encrypted = cipher.doFinal(srcString.getBytes());
		return bbase.byteArrayToBase64(encrypted);
	}

	public String decryptString(String srcString, String keyString, String cipherName) throws NoSuchAlgorithmException,
			NoSuchPaddingException, InvalidKeyException, IllegalBlockSizeException, BadPaddingException {
		byte[] araw = bbase.base64ToByteArray(keyString);
		SecretKeySpec skeySpec = new SecretKeySpec(araw, cipherName);
		Cipher cipher = Cipher.getInstance(cipherName);
		cipher.init(Cipher.DECRYPT_MODE, skeySpec);
		byte[] encrypted = bbase.base64ToByteArray(srcString);
		byte[] decrypted = cipher.doFinal(encrypted);
		return new String(decrypted);
	}

	public String encryptByteArrayToString(byte[] srcArray, String keyString, String cipherName)
			throws NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException, IllegalBlockSizeException,
			BadPaddingException {
		byte[] araw = bbase.base64ToByteArray(keyString);
		SecretKeySpec skeySpec = new SecretKeySpec(araw, cipherName);
		Cipher cipher = Cipher.getInstance(cipherName);
		cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
		byte[] encrypted = cipher.doFinal(srcArray);
		return bbase.byteArrayToBase64(encrypted);
	}

	public byte[] decryptStringToByteArray(String srcString, String keyString, String cipherName)
			throws NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException, IllegalBlockSizeException,
			BadPaddingException {
		byte[] araw = bbase.base64ToByteArray(keyString);
		SecretKeySpec skeySpec = new SecretKeySpec(araw, cipherName);
		Cipher cipher = Cipher.getInstance(cipherName);
		cipher.init(Cipher.DECRYPT_MODE, skeySpec);
		byte[] encrypted = bbase.base64ToByteArray(srcString);
		byte[] decrypted = cipher.doFinal(encrypted);
		return decrypted;
	}
}
