/*
 * Created on 11.12.2004
 */

package com;

import java.awt.BorderLayout;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JSplitPane;

import com.common.DataSave;
import com.common.IconMaker;
import com.panels.ProgressPanel;
import com.panels.ShowPanel;
import com.sss.Quacker;

/**
 * @author nemo
 */
public class MailChecker extends JPanel {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3258415044936021555L;

	private static JFrame frame;
	public static final String APP_NAME = "  MailChecker 1.1  ";
	public static final String VALIDATION = " Unregistered !!!  ";

	private DataSave sdata = new DataSave();

	private ShowPanel showPanel;

	private ExecThread executor;

	private ProcessThread processor;

	public long _max = 100;

	public long _value = 0;

	private SrcDataTabbedPane leftDataPanel;

	private ProgressPanel progress;

	private ToolBar topToolBar;

	private  JMenuBar _menuBar;
	
	private Quacker _qq;
	
	public Quacker getQq() {
		return _qq;
	}
	public static JFrame getFrame() {
        return frame;
    }

	public DataSave getDataSave() {
		return sdata;
	}

	public void exit() {
		progress.setStop();
		//mytim.setStop();
		frame.dispose();
	}

	public void setHeader(String title) {
		frame.setTitle("  MailChecker    " + title);
	}

	public void repaintShow() {
		showPanel.repaintShow();
	}

	public void showResultUsers() {
		showPanel.showResult(sdata);
		this.clean();
		leftDataPanel.repaintShow();
		topToolBar.setProcessEnabled(true);
		topToolBar.setBreakEnabled(false);
	}

	public void stop() {
		if (executor != null) {
			executor.setStop();
		}
		if (processor != null) {
			processor.setStop();
		}
	}

	public void start() {
		executor = new ExecThread(this);
	}

	public void process() {
		processor = new ProcessThread(this);
	}

	public void clean() {
		executor = null;
		processor = null;
		_value = 0;
		_max = 100;
	}

	public void clearAll() {
		sdata.clearAll();
		showPanel.clearAll();
	}

	public void clearResults() {
		sdata.clearResults();
		showPanel.clearAll();
	}

	public ProgressPanel getProgressBar() {
		return progress;
	}

	public MailChecker() {
		_menuBar = new JMenuBar();
		progress = new ProgressPanel(this);
		setLayout(new BorderLayout());
		topToolBar = new ToolBar(MailChecker.this,_menuBar,"Main",KeyEvent.VK_M);
		add(topToolBar, BorderLayout.NORTH);
		JSplitPane split = new JSplitPane();
		leftDataPanel = new SrcDataTabbedPane(this);
		showPanel = new ShowPanel(this);
		split.setOneTouchExpandable(true);
		split.setLeftComponent(leftDataPanel);
		split.setRightComponent(showPanel);
		split.setDividerLocation(280);
		split.setDividerSize(7);
		add(split, BorderLayout.CENTER);
		add(progress, BorderLayout.SOUTH);
		setOpaque(true);
		_qq = new Quacker(Quacker.TIME_CONSTRAINT);
		_qq.showUserAttributes();
	}
	
	public JMenuBar getMainMenu() {
		return _menuBar;
	}

	public static void main(String[] args) {
		frame = new JFrame("   MailChecker  registered to Academset");
		//frame = new JFrame("   MailChecker    UNREGISTERED !!!");
		frame.setIconImage(IconMaker.getIcon(IconMaker.MAIL_ICON).getImage());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		MailChecker mailChecker = new MailChecker();
		frame.getContentPane().add(mailChecker);
		frame.setJMenuBar(mailChecker.getMainMenu());
		int width = 900;
		int height = 580;
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		Rectangle rec = ge.getMaximumWindowBounds();
		double x0 = rec.x + rec.width / 2 - width / 2;
		double y0 = rec.y + rec.height / 2 - height / 2;
		rec.setRect(x0, y0, width, height);
		frame.setBounds(rec);
		// frame.pack();
		frame.setVisible(true);
	}

}
