/*
 * Created on 24.12.2004
 */
package com;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTabbedPane;

import com.panels.DomainsListPan;
import com.panels.FileListPan;
import com.panels.UserGroupPan;


/**
 * @author nemo
 */
public class SrcDataTabbedPane extends JTabbedPane{
	
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3258130249932944433L;

	private MailChecker _mainPanel;
	
	private DomainsListPan domainPan;
	
	private UserGroupPan userGroupPan;
	
	private FileListPan filePan;
	
	public void repaintShow() {
		filePan.repaintShow();
	}
	
	public SrcDataTabbedPane(MailChecker checker) {
		_mainPanel = checker;
		addMouseListener(new Click());
		filePan = new FileListPan(_mainPanel);
		domainPan = new DomainsListPan(_mainPanel);
		userGroupPan = new UserGroupPan(_mainPanel);
		addTab("Files", filePan);
		addTab("LocalDomains", domainPan);
		addTab("LocalUsers", userGroupPan);
	}
	
	class Click extends MouseAdapter {
		public void mouseClicked(MouseEvent e) {
			switch (SrcDataTabbedPane.this.getSelectedIndex()) {
			case 1:
				domainPan.repaintShow();
				break;
			case 2:
				userGroupPan.repaintShow();
				break;
			}
		}
	}

}
