
package com;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.JMenuBar;

import com.common.IconMaker;
import com.common.MenuToolBar;
import com.common.ToolButton;
import com.custom.CustomizerDialog;
import com.dialogs.AboutDialog;
import com.sss.RegDialog;

/*
 * Created on 12.12.2004
 */

/**
 * @author nemo
 */
public class ToolBar extends MenuToolBar {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3257004375829131574L;

	private MailChecker _mainPanel;
	
	private ProcessButton processButton = new ProcessButton();
	
	private BreakButton breakButton = new BreakButton();
	
	public ToolBar(MailChecker owner,JMenuBar menuBar,String tbName,int mnemonic) {
		super(menuBar, tbName, mnemonic);
		_mainPanel = owner;
		addButton(new ClearButton());
		addButton(new AnalyzeButton());
		addButton(processButton);
		addButton(breakButton);
		addSeparator();
		addButton(new ExitButton());
		addSeparator();
		//addButton(new CustomizeButton());
		addButton(new AboutButton());
		//addButton(new RegButton());
		setFloatable(false);
		processButton.setEnabled(false);
		breakButton.setEnabled(false);
	}
	
	public void setProcessEnabled(boolean setstate) {
		processButton.setEnabled(setstate);
	}
	
	public void setBreakEnabled(boolean setstate) {
		breakButton.setEnabled(setstate);
	}
	
	private class ClearButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3257569490513179447L;

		public ClearButton() {
			super("Clear All",IconMaker.getIcon16(IconMaker.CLEAR_ICON));
			createMenuItem("Clear All",KeyEvent.VK_1, ActionEvent.ALT_MASK);
		}
		
		public void runClick() {
			_mainPanel.clearAll();
			processButton.setEnabled(false);
		}
	}
	
	private class AnalyzeButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3256444685806482996L;

		public AnalyzeButton() {
			super( "Load and Process",IconMaker.getIcon16(IconMaker.EXECUTE_ICON));
			createMenuItem( "Load and Process",KeyEvent.VK_2, ActionEvent.ALT_MASK);
		}

		public void runClick() {
			breakButton.setEnabled(true);
			_mainPanel.start();
		}
	}
	
	private class ProcessButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3834305133541929778L;

		public ProcessButton() {
			super( "Process",IconMaker.getIcon16(IconMaker.PROCESS_ICON));
			createMenuItem( "Process",KeyEvent.VK_3, ActionEvent.ALT_MASK);
		}

		public void runClick() {
			breakButton.setEnabled(true);
			_mainPanel.process();
		}
	}

	private class BreakButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3258417222534641717L;

		public BreakButton() {
			super( "Break",IconMaker.getIcon16(IconMaker.BREAK_ICON));
			createMenuItem( "Break",KeyEvent.VK_4, ActionEvent.ALT_MASK);
		}
		
		public void runClick() {
			_mainPanel.stop();
		}
	}
	
	
	private class AboutButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3256444715871319601L;

		public AboutButton() {
			super( "About",IconMaker.getIcon16(IconMaker.ABOUT_ICON));
			createMenuItem("About",KeyEvent.VK_6, ActionEvent.ALT_MASK);
		}

		public void runClick() {
			new AboutDialog(_mainPanel);
		}
	}
	
	private class CustomizeButton extends ToolButton {
		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3977302131093092407L;

		public CustomizeButton() {
			super( "Customize",IconMaker.getIcon16(IconMaker.CUSTOMIZE_ICON));
			createMenuItem("Customize",KeyEvent.VK_8, ActionEvent.ALT_MASK);
		}

		public void runClick() {
			new CustomizerDialog(_mainPanel);
		}
	}
	
	private class ExitButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3257284746999575603L;

		public ExitButton() {
			super( "Exit",IconMaker.getIcon16(IconMaker.EXIT_ICON));
			createMenuItem( "Exit",KeyEvent.VK_7,-1);
		}

		public void runClick() {
			_mainPanel.exit();
		}
	}

	private class RegButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3256444715871319601L;

		public RegButton() {
			super("Register", IconMaker.getIcon16(IconMaker.REG_ICON));
			createMenuItem("Register", KeyEvent.VK_5, -1);
		}

		public void runClick() {
			RegDialog dlg = new RegDialog(_mainPanel);
			if(dlg.isSaved()) {
				_mainPanel.getQq().saveKeyDataToPrefs(dlg.getKeyFileName());
				_mainPanel.getQq().showUserAttributes();
			}
		}
	}
}
