package com.common;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Arrays;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JMenuItem;

import com.custom.ICustomize;
import com.custom.PropKit;

/*
 * Created on 14.12.2004
 */

public class ToolButton extends JButton implements ICustomize{

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3256436989157847350L;
	private static char[] nameLen  = new char[16];
	
	private JMenuItem _menuItem;
	
	private int _mnemonic=-1;
	private int _modifier=-1;
	
	private PropKit _propKit;
	
	public JMenuItem createMenuItem(String mname,int mnemonic,int modifier) {
		_mnemonic = mnemonic;
		_modifier = modifier;
		_menuItem = new JMenuItem(mname,mnemonic);
		_menuItem.addActionListener(new menuClick());
//		if(_modifier>0) {
//			_propKit.putProp(new MenuAcceleratorProperty("Accelerator",
//					KeyEvent.getKeyText(_mnemonic)+" + "+KeyEvent.getKeyModifiersText(_modifier),_menuItem));
//			_menuItem.setAccelerator(KeyStroke.getKeyStroke(_mnemonic,_modifier));
//		}
		return _menuItem;
	}
	
	public JMenuItem getMenuItem() {
		return _menuItem;
	}
	
	public ToolButton( String text,Icon bicon) {
		super(getButNameLen(text),bicon);
		_propKit = new PropKit(text);
		//setVerticalTextPosition(SwingConstants.BOTTOM);
		//setHorizontalTextPosition(SwingConstants.CENTER);
		addMouseListener(new Click());
	}
	
	public ToolButton(Icon bicon,String text) {
		super(bicon);
		_propKit = new PropKit(text);
		setToolTipText(text);
		addMouseListener(new Click());
	}
	
	private static String getButNameLen(String name) {
		Arrays.fill(nameLen,' ');
		String dop = new String(nameLen);
		StringBuffer buf = new StringBuffer(dop);
		int middles = nameLen.length/2-name.length()/2;
		buf.replace(middles,middles+name.length(),name);
		return buf.toString();
	}

	class Click extends MouseAdapter {
		public void mouseClicked(MouseEvent e) {
			ToolButton.this.runClick();
		}
	}
	
	class menuClick implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			ToolButton.this.runClick();
		}
	}
	
	public void runClick() {
		
	}

	public void setPropKit(PropKit pkit) {
		_propKit = pkit;
	}

	public PropKit getPropKit() {
		return _propKit;
	}

	public String getkitName() {
		return null;
	}

	public void refreshProps() {
	}
	
}