package com.common;

import java.awt.Color;

/*
 * Created on 13.12.2004
 */

/**
 * @author nemo
 */
public class UserBox implements TableRow {

	protected String _name;

	protected Float _incoming = new Float(0);

	protected Float _outgoing = new Float(0);

	protected Float _localIn = new Float(0);

	protected Float _localOut = new Float(0);

	protected boolean _isExpanded = false;

	protected boolean _isShow = true;

	protected UserBox _domain;

	protected int _isFooter = -1;

	protected int _isHeader = -1;

	protected Color _rowColor;

	public UserBox getDomain() {
		return _domain;
	}

	public boolean hasDomain() {
		if (_domain != null)
			return true;
		return false;
	}

	public boolean isExpanded() {
		return _isExpanded;
	}

	public boolean isShow() {
		return _isShow;
	}

	public Object getField(int ind) {
		Object ret = "";
		switch (ind) {
		case 1:
			if (_domain != null)
				ret = _domain._name;
			break;
		case 2:
			ret = _name;
			break;
		case 3:
			ret = _incoming;
			break;
		case 4:
			ret = _outgoing;
			break;
		case 5:
			ret = _localIn;
			break;
		case 6:
			ret = _localOut;
			break;
		}
		return ret;
	}

	protected String getNumStr(Float num) {
		String res = num.toString();
		if (num.intValue() > 1073741824)
			res = Math.round(num.floatValue() / 1024 / 1024 / 1024) + " Gb";
		else if (num.intValue() > 1048576)
			res = Math.round(num.floatValue() / 1024 / 1024) + " Mb";
		else if (num.intValue() > 1024)
			res = Math.round(num.floatValue() / 1024) + " Kb";
		else if (num.intValue() == 0)
			res = "";
		return res;
	}

	public Object getValueAt(int columnIndex) {
		return getField(columnIndex);
	}

	public void setValueAt(Object aValue, int columnIndex) {
		Object ret = getField(columnIndex);
		ret = aValue;
	}

	public UserBox(String dName, UserBox domain) {
		_name = dName;
		_domain = domain;
	}

	public void AddBytesIncoming(int value) {
		_incoming = new Float(value + _incoming.intValue());
	}

	public void AddBytesOutgoing(int value) {
		_outgoing = new Float(value + _outgoing.intValue());
	}

	public void AddBytesLocalIn(int value) {
		_localIn = new Float(value + _localIn.intValue());
	}

	public void AddBytesLocalOut(int value) {
		_localOut = new Float(value + _localOut.intValue());
	}

	public Color getRowColor() {
		return _rowColor;
	}

	public void setHeader(int val) {
		_isHeader = val;
	}

	public void setFooter(int val) {
		_isFooter = val;
	}

	public int getHeader() {
		return _isHeader;
	}

	public int getFooter() {
		return _isFooter;
	}

	public void setRowColor(Color val) {
		_rowColor = val;
	}

	/**
	 * @return Returns the incoming.
	 */
	public Float getIncoming() {
		return _incoming;
	}

	/**
	 * @param incoming The incoming to set.
	 */
	public void setIncoming(Float incoming) {
		if (incoming != null)
			_incoming = incoming;
	}

	/**
	 * @return Returns the localIn.
	 */
	public Float getLocalIn() {
		return _localIn;
	}

	/**
	 * @param localIn The localIn to set.
	 */
	public void setLocalIn(Float localIn) {
		if (localIn != null)
			_localIn = localIn;
	}

	/**
	 * @return Returns the localOut.
	 */
	public Float getLocalOut() {
		return _localOut;
	}

	/**
	 * @param localOut The localOut to set.
	 */
	public void setLocalOut(Float localOut) {
		if (localOut != null)
			_localOut = localOut;
	}

	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return _name;
	}

	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		_name = name;
	}

	/**
	 * @return Returns the outgoing.
	 */
	public Float getOutgoing() {
		return _outgoing;
	}

	/**
	 * @param outgoing The outgoing to set.
	 */
	public void setOutgoing(Float outgoing) {
		if (outgoing != null)
			_outgoing = outgoing;
	}

	/**
	 * @param domain The domain to set.
	 */
	public void setDomain(UserBox domain) {
		_domain = domain;
	}

	/**
	 * @param isExpanded The isExpanded to set.
	 */
	public void setExpanded(boolean isExpanded) {
		_isExpanded = isExpanded;
	}

	/**
	 * @param isShow The isShow to set.
	 */
	public void setShow(boolean isShow) {
		_isShow = isShow;
	}

	public int compareRows(Object arg0) {
		TableRow enemy = (TableRow) arg0;
		if (_isHeader < enemy.getHeader())
			return -1;
		if (_isHeader > enemy.getHeader())
			return 1;
		if (_isFooter < enemy.getFooter())
			return -1;
		if (_isFooter > enemy.getFooter())
			return 1;
		return 0;
	}
}
