/*
 * Created on 01.01.2005
 */
package com.custom;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.SwingUtilities;

import com.common.IconMaker;
import com.common.PositionUtilities;
import com.common.ToolButton;

/**
 * @author nemo
 */
public class CustomizerDialog  extends JDialog  implements Serializable {
	
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3689346624409056313L;
	
	private boolean isSaved = false;
	
	private ArrayList <ICustomize> compProps = new ArrayList <ICustomize>();
	
	public void putProp(ICustomize propList) {
		compProps.add(propList);
	}
	
	public CustomizerDialog(Component owner) {
		super((Frame) SwingUtilities.getWindowAncestor( owner),true);
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(getButtonPanel(),BorderLayout.SOUTH);
		getContentPane().add(getMainPanel(),BorderLayout.CENTER);
		setSize(600,500);
		PositionUtilities.setCentered(this);
		setVisible(true);
	}

	private Component getMainPanel() {
		JSplitPane split = new JSplitPane();
		split.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
		split.setOneTouchExpandable(true);
		split.setLeftComponent(getPropTree());
		split.setRightComponent(getPropPane());
		split.setDividerLocation(150);
		split.setDividerSize(7);
		return split;
	}
	
	private Component getPropPane() {
		JPanel pan = new JPanel();
		return pan;
	}

	private Component getPropTree() {
		JPanel pan = new JPanel();
		return pan;
	}

	private JPanel getButtonPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());
		panel.add(new OKButton());
		panel.add(new SaveButton());
		panel.add(new CancelButton());
		panel.setBorder(BorderFactory.createEtchedBorder());
		return panel;
	}
	
	public boolean isSaved() {
		return isSaved;
	}
	
	private class OKButton extends ToolButton{

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 4050200821561833270L;

		public OKButton() {
			super("OK",IconMaker.getIcon16(IconMaker.OK_ICON));
		}
		
		public void runClick() {
			isSaved = true;
			setPropsAnyWhere();
			CustomizerDialog.this.dispose();
		}

		private void setPropsAnyWhere() {
			Iterator i = compProps.iterator();
			while(i.hasNext()) {
				((ICustomize)i.next()).refreshProps();
			}
		}
		
	}
	
	private class CancelButton extends ToolButton{

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3546643192066750007L;

		public CancelButton() {
			super("Close",IconMaker.getIcon16(IconMaker.DEFAULT_ICON));
		}
		
		public void runClick() {
			CustomizerDialog.this.dispose();
		}
		
	}
	
	private class SaveButton extends ToolButton{
		
		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3904679388112171577L;

		public SaveButton() {
			super("Save",IconMaker.getIcon16(IconMaker.SAVE_ICON));
		}
		
		public void runClick() {
			JFileChooser chooser = new JFileChooser();
			chooser.setDialogType(JFileChooser.FILES_ONLY);
			chooser.setSelectedFile(new File("mailLogs.txt"));
			int returnVal = chooser.showSaveDialog(CustomizerDialog.this);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				setFileContent(chooser.getSelectedFile());
				CustomizerDialog.this.dispose();
			}
		}
	}

	public void setFileContent(File selectedFile) {
	}
}
