/*
 * Created on 31.01.2005
 */
package com.panels;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.KeyEvent;
import java.io.File;

import javax.swing.Box;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.common.IconMaker;
import com.common.ToolButton;

/**
 * @author nemo
 */
public class FileNamePanel extends JPanel{
	
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 4121130333765710904L;
	private static final int strut = 5;
	private JTextField _name = new JTextField(getUserFile());
	
	private File currDir;
	
	private Component _mainPanel;
    
    protected String getUserFile() {
        return System.getProperty("user.home") + System.getProperty("file.separator") + "keys.ddt";
    }
	
	private class OpenButton extends ToolButton{

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3257282530745988921L;

		public OpenButton() {
			super(IconMaker.getIcon(IconMaker.SAVE_ICON),"Open");
			createMenuItem("Create Key",KeyEvent.VK_1, -1);
		}
		
		public void runClick() {
			JFileChooser chooser = new JFileChooser();
			if(currDir != null){
				chooser.setSelectedFile(currDir);
            }else{
                chooser.setSelectedFile(new File(getUserFile()));
            }
			chooser.setDialogType(JFileChooser.FILES_ONLY);
			chooser.setMultiSelectionEnabled(false);
			int returnVal = chooser.showOpenDialog(_mainPanel);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				currDir = chooser.getSelectedFile();
				_name.setText(currDir.getAbsolutePath());
			}
		}
	}
	
	public FileNamePanel(Component mainPanel,String label) {
		_mainPanel = mainPanel;
		setLayout(new BorderLayout());
		Box bh = Box.createHorizontalBox();
		bh.add(Box.createHorizontalStrut(strut+5));
		bh.add(new JLabel(label));
		bh.add(Box.createHorizontalStrut(strut));
		bh.add(_name);
		bh.add(Box.createHorizontalStrut(strut));
		bh.add(new OpenButton());
		bh.add(Box.createHorizontalStrut(strut+5));
		add(bh,BorderLayout.CENTER);
	}


	public String getName() {
		return _name.getText();
	}
	
	public void setName(String name) {
		_name.setText(name);
	}
}
