
package com.panels;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.Timer;

import com.MailChecker;

/*
 * Created on 12.12.2004
 */

/**
 * @author nemo
 */
public class ProgressPanel extends JPanel {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3258130262851334451L;

	private JProgressBar progressBar;
	
	private MailChecker _checker;
	
	private Timer mytim;
	
	private StatusBar sbar;
	
	public void setStop() {
		if(mytim != null)
			mytim.stop();
	}

	public ProgressPanel(MailChecker checker) {
		_checker = checker;
		setLayout(new BorderLayout());
		progressBar = new JProgressBar(0, 100);
		progressBar.setValue(0);
		progressBar.setStringPainted(true);
		progressBar.setForeground(Color.BLUE);
		progressBar.setBorder(BorderFactory.createEtchedBorder());
		Box bv = Box.createVerticalBox();
		bv.add(Box.createVerticalStrut(2));
		bv.add(progressBar);
		bv.add(Box.createVerticalStrut(2));
		sbar = new StatusBar();
		bv.add(sbar);
		bv.add(Box.createVerticalStrut(2));
		Box bh = Box.createHorizontalBox();
		bh.add(Box.createHorizontalStrut(2));
		bh.add(bv);
		bh.add(Box.createHorizontalStrut(2));
		add(bh, BorderLayout.CENTER);
		mytim = new Timer(100,new TimerAction());
		mytim.start();
	}
	
	public void setStatustext(String text) {
		sbar._status.setText(text);
	}

	public void setProgress(long pvalue, long max) {
		progressBar.setValue(0);
		if(max != progressBar.getMaximum())
		progressBar.setMaximum((int) max);
		if(pvalue != progressBar.getValue())
		progressBar.setValue((int) pvalue);
		sbar._seanses.setText(String.valueOf(_checker.getDataSave().getRawData().size()));
		sbar._domains.setText(String.valueOf(_checker.getDataSave().getDomains().size()));
		sbar._users.setText(String.valueOf(_checker.getDataSave().getUsers().size()));
	}
	
	private class TimerAction implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			setProgress(_checker._value, _checker._max);
		}
		
	}

}
