package com.panels;
import java.awt.BorderLayout;
import java.awt.event.KeyEvent;
import java.util.Iterator;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTable;

import com.MailChecker;
import com.common.DataSave;
import com.common.DomainTotalFactory;
import com.common.TablePanel;
import com.common.UserBox;
import com.common.UserTotalFactory;

/*
 * Created on 12.12.2004
 */

/**
 * @author nemo
 */
public class ShowPanel extends JPanel{
	
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3257845497895989811L;

	private TablePanel userTable;
	
	private TablePanel domainTable;
	
	private JTabbedPane tabs;
	
	private String[] _columnNamesUser = { "NN","Domain", "MailBox", "Incoming", "Outgoing" , "LocalIn","LocalOut"};
	
	private String[] _columnNamesDomain = { "NN","Domain", "Incoming", "Outgoing" , "LocalIn","LocalOut"};
	
	private MailChecker _mainPanel;
	
	public ShowPanel(MailChecker owner) {
		_mainPanel = owner;
		setLayout(new BorderLayout());
		userTable = new TablePanel("Users",_mainPanel,KeyEvent.VK_U,_columnNamesUser,new UserTotalFactory());
		domainTable = new TablePanel("Domains",_mainPanel,KeyEvent.VK_D,_columnNamesDomain,new DomainTotalFactory());
		tabs = new JTabbedPane();
		tabs.addTab("Users",userTable);
		tabs.addTab("Domains",domainTable);
		add(tabs, BorderLayout.CENTER);
	}

	public JTable getTable() {
		return userTable.getTable();
	}
	
	public void repaintShow() {
		userTable.repaintShow();
		domainTable.repaintShow();
	}
	
	public void clearAll() {
		userTable.clearRows();
		domainTable.clearRows();
		repaintShow();
	}
	
	public void showResult(DataSave datas) {
		Iterator i =  datas.getUsers().iterator();
		userTable.clearRows();
		while(i.hasNext()) {
			userTable.addRow((UserBox) i.next());
		}
		userTable.repaintShow();
		i =  datas.getDomains().values().iterator();
		domainTable.clearRows();
		while(i.hasNext()) {
			domainTable.addRow((UserBox) i.next());
		}
		domainTable.repaintShow();
	}

	public void printResults() {
		if(tabs.getSelectedIndex() == 0)
			userTable.printTable();
		else
			domainTable.printTable();
	}
}
