/*
 * Created on 11.02.2005
 */
package com.sss;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Frame;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import com.common.IconMaker;
import com.common.PositionUtilities;
import com.common.ToolButton;
import com.panels.FileNamePanel;

/**
 * @author nemo
 */
public class RegDialog extends JDialog{
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3904964161657451315L;

	private boolean isSaved = false;

	private FileNamePanel _fname = new FileNamePanel(RegDialog.this, "Key file      ");
    
	private class OKButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3762816008473555506L;

		public OKButton() {
			super("OK", IconMaker.getIcon(IconMaker.OK_ICON));
		}

		public void runClick() {
			isSaved = true;
            RegDialog.this.dispose();
		}
	}

	private class CancelButton extends ToolButton {

		/**
		 * Comment for <code>serialVersionUID</code>
		 */
		private static final long serialVersionUID = 3258131362279076150L;

		public CancelButton() {
			super("Cancel", IconMaker.getIcon(IconMaker.DEFAULT_ICON));
		}

		public void runClick() {
			RegDialog.this.dispose();
		}

	}

	private JPanel getButtonPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());
		panel.add(new OKButton());
		panel.add(new CancelButton());
		panel.setBorder(BorderFactory.createEtchedBorder());
		return panel;
	}

	private JPanel getMainPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		Box bv = Box.createVerticalBox();
		bv.add(Box.createVerticalStrut(5));
		bv.add(_fname);
		bv.add(Box.createVerticalStrut(5));
		panel.add(bv, BorderLayout.CENTER);
		panel.setBorder(BorderFactory.createEtchedBorder());
		return panel;
	}

	public RegDialog(Component mainPan) {
		super((Frame) SwingUtilities.getWindowAncestor(mainPan), true);
		setTitle("Please Select a key-file !");
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(getButtonPanel(), BorderLayout.SOUTH);
		getContentPane().add(getMainPanel(), BorderLayout.CENTER);
		setSize(600, 110);
		PositionUtilities.setCentered(this);
		_fname.setName("");
		setVisible(true);
	}

	public boolean isSaved() {
		return isSaved;
	}

	public String getKeyFileName() {
		return _fname.getName();
	}
}

